Self-hosting
============

Self-hosting is the activity of having and administrating your own server, typically at home, to host your personal data and services yourself instead of relying exclusively on third-parties. For instance, you can self-host your blog, such that it 'lives' on a machine that you have control on, instead of having it on somebody else's computer (a.k.a. The Cloud) in exchange for money, advertisement or private data.

Self-hosting implies owning a server. A server is a computer which is typically accessible on the network 24/7, and usually does not have any screen or keyboard (it is instead controlled remotely). Contrarily to a popular belief, a server is not necessarily a huge and extra-powerful machine : nowadays, a small, ~$30 ARM board is adequate for self-hosting.

Self-hosting is not about making "your Internet" more secure or does not provide anonymity by itself. Instead, it is about being autonomous, and in control of your services and data - which also means being responsible for them.

Why should you host yourself ?
------------------------------

- **You believe in a free, open and decentralized internet.** In a centralized internet, private companies and governement can spy, analyze and influence people by dictating how they connect with each other, and by filtering content. Yunohost is developed by a community who believe in an open and decentralized internet, and we hope that you do, too !

- **You want to have control on your data and services.** Your pictures, chat messages, browsing history, and that text you are writing for school, have nothing to do on somebody else's server (a.k.a. The Cloud). They are part of your private life, but also part of your family's life, your friend's life, and so on. These data should be managed by *you*, not a random company in the US who wants your data to analyze them and sell the results.

- **You want to learn about how computers and the Internet work.** Operating your own server is a pretty good context to understand the basic mechanisms at the heart of operating systems and the Internet. You might have to deal with command line interface, network architecture, DNS configuration, SSH, and so on.

- **You want to explore new possibilities and customize things.** Ever dreamed of running a Minecraft server for you friends, or a persistent IRC or XMPP client ? With you very own server, you can manually install and run virtually any program you want, and customize every bits.

Why should you *not* host yourself ?
------------------------------------

- **Self-hosting requires some work and patience.** Hosting yourself is a bit like growing your own garden or vegetables : it requires work and patience. While YunoHost aims to do all the hard work for you, self-hosting still requires that you take time to learn and configure a few things to setup your server properly. You will also need to perform maintenance tasks (such as upgrades) from time to time, or to ask for support if some things break.

- **With great servers comes great responsabilities.** Operating a server means that you are responsible of the data you are hosting. Nobody will be able to recover them for you if they get lost. YunoHost provides backup features, which you should use regularly to backup the configurations and data you care about. You should also keep and eye on security news and recommentations so that your server or critical data don't get compromised.

- **Quality and performance probably won't be as good as premium services.** YunoHost (and most of the applications packaged for it) are free and open-source softwares, developped by communities of people in their free time and on the basis of best effort. There is no absolute guarantee that software will work in every possible circumstances. The performance of your self-hosted server is also related to its CPU and RAM, and to the available internet connectivity.

